#include "tcl.h"
#include "process.h"
#include "ygg.h"

int Runtime_Init _ANSI_ARGS_ ((Tcl_Interp *interp)); 	
int Runtime_Task _ANSI_ARGS_ ((ClientData data));

static long counter;
static int pid;
/*
 * This is an example task
 * Creates a node on the tree, 
 * and links a C variable to it.
 *
 * It creates a process that increments 
 * the value every second
 *
 */

int Runtime_Init(interp) 
	Tcl_Interp *interp;
{
	YggNode *thisNode;
	Tcl_Obj *valptr;

	/*
	 * Find an entry in the tree, 
	 * or create new one if not found
	 */
	thisNode = Ygg_Record("/env.runtime",-1,1);
	
	/*
	 * Place an empty value in the tree
	 */
	valptr = Tcl_NewLongObj(0);
	Ygg_SetObj(thisNode,valptr);

	/*
	 * Link our C variable with the tree
	 */
	counter = 0;
	Tcl_LinkVar(interp,"/env.runtime",(char *)&counter,TCL_LINK_INT);
	
	/*
	 * Generate new process
	 */
	pid = ProcessCreate(&Runtime_Task,(ClientData)interp);
	Odie_SetProcessPeriod(pid,1000000); /* Call every sec. */
	
	/* Start the process */
	Odie_StartProcess(pid);
	
	/* Return */
	return TCL_OK;
}


int Runtime_Task(data)
	ClientData data;
{
	Tcl_Interp *interp = (Tcl_Interp *)data;

	counter++;
	
	Tcl_UpdateLinkedVar(interp, "/env.runtime");
	/* 
	 * Return codes:
	 *	TCL_OK, TCL_CONTINUE 	continue
	 *	TCL_ERROR				halt task
	 *	TCL_BREAK				suspend task
	 */
	return TCL_OK;
}
