/*
 * Odie List Utilites
 */
#include <tcl.h>

int OList_Init _ANSI_ARGS_((Tcl_Interp *interp));

int OList_Init(interp) 
	Tcl_Interp *interp;
{
	Tcl_Eval(interp,"\
proc string.to.args { str {phyrst {}} } { \n\
	set entry $phyrst\n\
	set val {}\n\
	foreach item $str {\n\
		if { [string index $item 0] == \"-\" } {\n\
			set result($entry) $val\n\
			set entry [string range $item 1 end]\n\
			set val {}\n\
		} else {\n\
			lappend val $item\n\
		}\n\
	}\n\
	set result($entry) $val\n\
	if [info exists result()] {\n\
		unset result()\n\
	}\n\
	return [array get result]\n\
}\n\
\n\
proc ladd {VAR VAL} {\n\
	upvar $VAR LIST\n\
	if ![info exists LIST] { \n\
		lappend LIST $VAL \n\
	} else {\n\
		if { [lsearch $LIST $VAL] < 0 } { lappend LIST $VAL }\n\
	}\n\
}\n\
\n\
proc ldelete {LIST args} {\n\
	foreach val $args {\n\
		set index [lsearch $LIST $val]\n\
		if { $index >= 0 } {\n\
			set LIST [lreplace $LIST $index $index]\n\
		}\n\
	}\n\
	return $LIST\n\
}\n\
\n\
proc lreverse { LIST } {\n\
	set len [expr [llength $LIST] - 1]\n\
	set result {}\n\
	for { set x $len } { $x >= 0 } { incr x -1 } {\n\
		lappend result [lindex $LIST $x]\n\
	}\n\
	return $result\n\
}\n\
\n\
proc lset {STRING VARS} {\n\
	for { set loop 0 } {$loop < [llength $STRING]} { incr loop } {\n\
		upvar 1 [lindex $VARS $loop] temp\n\
		set temp [lindex $STRING $loop]\n\
	}\n\
}\n\
\n\
proc lremove {VAR args} {\n\
	upvar $VAR LIST\n\
	if ![info exists LIST] return\n\
	foreach val $args {\n\
		set index [lsearch $LIST $val]\n\
		if { $index >= 0 } {\n\
			set LIST [lreplace $LIST $index $index]\n\
		}\n\
	}\n\
}\n\
	\n\
proc lfifo { stackvar linevar {len 1}} {\n\
	upvar 1 $stackvar stack $linevar line\n\
	if [set result [llength $stack]] {\n\
		set line [lrange $stack 0 [expr $len - 1]]\n\
		set stack [lrange $stack $len end]\n\
	}\n\
	return $result\n\
}\n\
\n\
proc lpop { stackvar {storevar {}}} {\n\
	upvar 1 $stackvar stack\n\
	if ![info exists stack] return\n\
	set line [lindex $stack end]\n\
	set stack [lreplace $stack end end]\n\
	if {$storevar != {}} {\n\
		upvar 1 $storevar store\n\
		set store $line\n\
		return [llength $stack]\n\
	}\n\
	return $line\n\
}\n\
\n\
proc lpush { stackvar line} {\n\
	upvar 1 $stackvar stack\n\
	lappend stack $line\n\
}\n\
\n\
proc lpeek { stackvar } {\n\
	upvar 1 $stackvar stack\n\
	return [lindex $stack end]\n\
}\n\
\n\
proc get { var } {\n\
	upvar 1 $var data\n\
	if [info exist data] { return $data }\n\
}\n\
\n\
proc wait { msec } {\n\
	update\n\
	after $msec { set pause 1 }\n\
	vwait pause\n\
}\n\
");
	return TCL_OK;
}
