/*
 * odieCode.r
 *
 *	Encodes text resources as Tcl Scripts
 *
 * Copyright (c) 1999 Woods Design Services and Sean Woods
 *
 * See the file "odie.license" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */
#define RESOURCE_INCLUDED
#include <tcl.h>
#include <tk.h>

#include <Types.r>
#include <SysTypes.r>
#include <AEUserTermTypes.r>

#define ODIE_VERSION "1.0"
/* Code Resources */

read 'TEXT' (0, "Init", purgeable, preload) 
	":::tcl" TCL_VERSION ":library:init.tcl";
read 'TEXT' (1, "History", purgeable, preload) 
	":::tcl" TCL_VERSION ":library:history.tcl";
read 'TEXT' (2, "Word", purgeable,preload) 
	":::tcl" TCL_VERSION ":library:word.tcl";

read 'TEXT' (10, "tk", purgeable, preload) 		
	":::tk" TK_VERSION ":library:tk.tcl";
read 'TEXT' (11, "button", purgeable, preload) 	
	":::tk" TK_VERSION ":library:button.tcl";
read 'TEXT' (12, "entry", purgeable, preload) 	
	":::tk" TK_VERSION ":library:entry.tcl";
read 'TEXT' (13, "listbox", purgeable, preload) 
	":::tk" TK_VERSION ":library:listbox.tcl";
read 'TEXT' (14, "menu", purgeable, preload) 	
	":::tk" TK_VERSION ":library:menu.tcl";
read 'TEXT' (15, "scale", purgeable, preload) 	
	":::tk" TK_VERSION ":library:scale.tcl";
read 'TEXT' (16, "scrollbar", purgeable, preload) 
	":::tk" TK_VERSION ":library:scrlbar.tcl";
read 'TEXT' (17, "text", purgeable, preload) 	
	":::tk" TK_VERSION ":library:text.tcl";
read 'TEXT' (18, "dialog", purgeable, preload) 	
	":::tk" TK_VERSION ":library:dialog.tcl";
read 'TEXT' (19, "focus", purgeable, preload) 	
	":::tk" TK_VERSION ":library:focus.tcl";
read 'TEXT' (20, "optionMenu", purgeable, preload) 
	":::tk" TK_VERSION ":library:optMenu.tcl";
read 'TEXT' (21, "palette", purgeable, preload) 
	":::tk" TK_VERSION ":library:palette.tcl";
read 'TEXT' (22, "tearoff", purgeable, preload) 
	":::tk" TK_VERSION ":library:tearoff.tcl";

read 'TEXT' (24, "comdlg", purgeable, preload) 	
	":::tk" TK_VERSION ":library:comdlg.tcl";
read 'TEXT' (25, "msgbox", purgeable, preload) 	
	":::tk" TK_VERSION ":library:msgbox.tcl";

read 'TEXT' (27, "colorPicker", purgeable, preload) 
	":::tk" TK_VERSION ":library:clrpick.tcl";
read 'TEXT' (28, "fileBox", purgeable, preload) 
	":::tk" TK_VERSION ":library:tkfbox.tcl";

read 'TEXT' (30, "Console", purgeable, preload) 
	":::Odie" ODIE_VERSION ":library:console.tcl";
read 'TEXT' (31, "tkerror", purgeable, preload) 
	":::Odie" ODIE_VERSION ":library:bgerror.tcl";
