//#include <Gestalt.h>
//#include <ToolUtils.h>
//#include <Fonts.h>
//#include <Dialogs.h>
//#include <SegLoad.h>
//#include <Traps.h>
//#include <Appearance.h>
//#include <SpeechSynthesis.h>

//#include "tk.h"
//#include "tkInt.h"
//#include "tkWinInt.h"

#include "process.h"
#include "matrices.h"
//#include "grafixMonorailTclInterface.h"

#pragma export on
#  undef TCL_STORAGE_CLASS
#  define TCL_STORAGE_CLASS DLLEXPORT

int Odie_Init	_ANSI_ARGS_(( Tcl_Interp *interp ));
int Odie_SafeInit _ANSI_ARGS_((Tcl_Interp *interp));

# undef TCL_STORAGE_CLASS
# define TCL_STORAGE_CLASS DLLIMPORT
#pragma export reset

/* Fancy Time: Manually Select stub or no stub Here */
#define STUB

int Device_Init(Tcl_Interp *interp);
int Serial_Init(Tcl_Interp *interp);
int Matrix_Init(Tcl_Interp *tinterp);
int Process_Init(Tcl_Interp *tinterp);
int Tclapplescript_Init(Tcl_Interp *interp);
int Graphix_Init(Tcl_Interp *interp);
int OList_Init(Tcl_Interp *interp);
int Ygg_Init(Tcl_Interp *interp);
int Runtime_Init(Tcl_Interp *interp);
int Control_Init(Tcl_Interp *interp);
int grafix_init(Tcl_Interp *interp);

int Odie_Init( Tcl_Interp *interp ) {

	#ifdef STUB
	/* Load 'dem stubs */
    if (Tcl_InitStubs(interp, "8.0", 0) == NULL) {
		return TCL_ERROR;
    }	
    #endif
    /*
	 * Mark off what sections of the code we can start
	 */
	if (Matrix_Init(interp) == TCL_ERROR) {
    	Tcl_SetVar2(interp, "odie", "MATRIX", "0", TCL_GLOBAL_ONLY); 
	} else {
    	Tcl_SetVar2(interp, "odie", "MATRIX", "1", TCL_GLOBAL_ONLY); 	
	}	

	if (Process_Init(interp) == TCL_ERROR) {
    	Tcl_SetVar2(interp, "odie", "PROCESS", "0", TCL_GLOBAL_ONLY); 
	} else {
    	Tcl_SetVar2(interp, "odie", "PROCESS", "1", TCL_GLOBAL_ONLY);
	}
	
	if (Device_Init(interp) == TCL_ERROR) {
    	Tcl_SetVar2(interp, "odie", "DEVICE", "0", TCL_GLOBAL_ONLY); 
	} else {
    	Tcl_SetVar2(interp, "odie", "DEVICE", "1", TCL_GLOBAL_ONLY);
	}

#ifdef MAC_TCL	
	if(Serial_Init(interp) == TCL_ERROR) {
   		Tcl_SetVar2(interp, "odie", "SERIAL", "0", TCL_GLOBAL_ONLY); 
	} else {
    	Tcl_SetVar2(interp, "odie", "SERIAL", "1", TCL_GLOBAL_ONLY);	
	}
	if(grafix_init(interp)==TCL_ERROR) {
   		Tcl_SetVar2(interp,"odie","grafix","0",TCL_GLOBAL_ONLY);
	} else {
   		Tcl_SetVar2(interp,"odie","grafix","1",TCL_GLOBAL_ONLY);
	}
#endif
	if(Ygg_Init(interp) == TCL_ERROR) {
   		Tcl_SetVar2(interp, "odie", "YGG", "0", TCL_GLOBAL_ONLY); 
	} else {
    	Tcl_SetVar2(interp, "odie", "YGG", "1", TCL_GLOBAL_ONLY);	
	}

	OList_Init(interp);

	Tcl_PkgProvide(interp, "Odie", "1.2.2");

	/*
	 * Load example task
	 */
	Runtime_Init(interp);
//	Control_Init(interp);
	return TCL_OK;
}

/*
 *----------------------------------------------------------------------
 * Odie_SafeInit --
 *
 *      Initializes the devices package
 *
 * Results: 
 *      Nothing happens, since this is not a safe activity.
 *
 * Side Effects:
 *      None
 *
 *----------------------------------------------------------------------
 */

int 
Odie_SafeInit(interp)
    Tcl_Interp *interp;
{
 	if (Matrix_Init(interp) == TCL_ERROR) {
    	Tcl_SetVar2(interp, "odie", "MATRIX", "0", TCL_GLOBAL_ONLY); 
	} else {
    	Tcl_SetVar2(interp, "odie", "MATRIX", "1", TCL_GLOBAL_ONLY); 	
	}  
	Tcl_SetVar2(interp, "odie", "PROCESS", "0", TCL_GLOBAL_ONLY); 
	Tcl_SetVar2(interp, "odie", "DEVICE", "0", TCL_GLOBAL_ONLY);
    return TCL_OK;
}

